clc; clear; close all;

beta = 0.96; 
r = 1/beta-1; 
r = 0.05;
R = 0.1;
p = 0.002; 
alpha = 0.8; 
Ns = 2;
Pis = [0.9 0.1;0.1 0.9]; 
s = [1.15;0.85]; 
A = 0.1; 
B = 0.1; 

Nmax = 500;
Nmax2 = Nmax+30;
delta = 0.002;
Delta = (0:1:Nmax-1)'*delta;
Delta2 = (0:1:Nmax2-1)'*delta;

k_npl2 = (alpha*A/(R+B)*s).^(1/(1-alpha));
k_star2 = (alpha*A/R*s).^(1/(1-alpha));

Nk = 5;
Delta_k = zeros(Ns,Nk);
Delta_k(1,:) = linspace(k_npl2(1),k_star2(1),Nk);
Delta_k(1,2) = k_npl2(1)*10;
Delta_k(2,:) = linspace(k_npl2(1),k_star2(2),Nk);

k_star = zeros(Ns,1); 
for i = 1:Ns
    [xx,yy] = max(A*s(i)*Delta_k(i,:).^alpha-R*Delta_k(i,:));
    k_star(i) = Delta_k(i,yy);
end
V_star = (eye(Ns)-beta*Pis)\(A*s.*k_star.^alpha-R*k_star);

k_npl = zeros(Ns,1); 
[xx,yy] = max(A*s(1)*Delta_k(1,1:Nk).^alpha-R*Delta_k(1,1:Nk)-B*Delta_k(1,1:Nk));    
k_npl(1) = Delta_k(1,yy);
[xx,yy] = max(A*s(2)*Delta_k(2,1:Nk).^alpha-R*Delta_k(2,1:Nk)-B*Delta_k(2,1:Nk));    
k_npl(2) = Delta_k(2,yy);

G_npl =  B*k_npl;
b_npl =  A*s.*k_npl.^alpha-R*k_npl-G_npl+beta*Pis*G_npl;
V_npl = (eye(Ns)-beta*Pis)\(A*s.*k_npl.^alpha-R*k_npl-b_npl);

k_npl0 = k_npl;
b_npl0 = b_npl;
G_npl0 = G_npl;
V_npl0 = V_npl;
G_npl1 = G_npl;

Delta_b = zeros(Nmax,Nmax2);
bmaxid = zeros(Nmax,1);
for i = 1:Nmax 
    for j = 1:Nmax2 
        Delta_b(i,j) = Delta(i)-1/(1+r)*Delta2(j);
    end
    if (i ==1)
        bmaxid(i) = 1;
    else
        bmaxid(i) = max(find(Delta_b(i,:)>0));
    end
end 

VH_star =1/(1-beta)*(A*s(1)*k_star(1)^alpha-R*k_star(1));
Dbar0 = ones(2,1)*(VH_star-G_npl(1));
d0 = zeros(Ns,Nmax); V0 = d0;
d_npl = (eye(Ns)-beta*Pis)\b_npl;
for i = 1:Ns
    for j = 1:Nmax
        if (Delta(j)<=Dbar0(i))
            d0(i,j) = Delta(j);
            V0(i,j) = VH_star-Delta(j);
        else
            d0(i,j)  = d_npl(i);
            V0(i,j) = G_npl(i);
        end
    end
end
d_npl0 = d_npl;

Dhat0 = zeros(Ns,Nmax);
Dhatid0 = Dhat0;
for i = 1:Ns
    for j = 1:Nmax
        [Dhat0(i,j), Dhatid0(i,j)] = max(d0(i,1:j));
    end
end

G = B*Delta_k;
kL_star = k_star(2);
FL_star = A*s(2)*kL_star^alpha;
VL_star = 1/(1-beta)*(FL_star-R*kL_star);
GL_star = B*kL_star;

knplH = input('choose k^npl(sH) from 1 to 5 : ');
knplL = input('choose k^npl(sL) from 1 to 5 : ');
knplHdef = input('k^npl(sH) is chosen by argmax (1) or max (2) : ');
knplLdef = input('k^npl(sL) is chosen by argmax (1) or max (2) : ');

maxit = 400;
precision = 1.0e-3;
iteration = 1;
d1 = zeros(Ns,Nmax); V1 = zeros(Ns,Nmax);

for t = 1:maxit   
    
    b1id = zeros(Ns,Nmax); Dplusid1 = b1id; b1 = b1id;
    Dplus1 = b1id;
    k = zeros(Ns,Nmax);   
    
    k_npl1 = zeros(Ns,1); b_npl1 = k_npl1;
    check = zeros(Ns,1); npleval = zeros(Ns,Nk);
    i = 1;        
    temp = 0.0;
    temp = temp + beta*Pis(i,1)*((1-p)*V0(1,end)+p*V0(1,Dhatid0(1,end)));
    temp = temp + beta*Pis(i,2)*((1-p)*V0(2,end)+p*V0(2,Dhatid0(2,end)));
    npleval(i,:) = temp-B*Delta_k(i,:);
    k_npl1(i) = Delta_k(i,knplH);
    check(i) = B*k_npl1(i)-temp;
    if (knplHdef == 1)
        b_npl1(i) = A*s(i)*k_npl1(i)^alpha-R*k_npl1(i)-check(i);
    else
        b_npl1(i) = A*s(i)*k_npl1(i)^alpha-R*k_npl1(i);
    end
    
    i = 2;
    temp = 0.0;
    temp = temp + beta*Pis(i,1)*((1-p)*V0(1,end)+p*V0(1,Dhatid0(1,end)));
    temp = temp + beta*Pis(i,2)*((1-p)*V0(1,end)+p*V0(2,Dhatid0(2,end)));
    npleval(i,:) = temp-B*Delta_k(i,:);
    k_npl1(i) = Delta_k(i,knplL);
    check(i) = B*k_npl1(i)-temp;
    if (knplLdef == 1)
        b_npl1(i) = A*s(i)*k_npl1(i)^alpha-R*k_npl1(i)-check(i);
    else
        b_npl1(i) = A*s(i)*k_npl1(i)^alpha-R*k_npl1(i);
    end
    d_npl1 = (eye(Ns)-beta*(1-p)*Pis)\(b_npl1+beta*Pis*p*Dhat0(:,end));
    V_npl1 = (eye(Ns)-beta*(1-p)*Pis)\(A*s.*k_npl1.^alpha-R*k_npl1-b_npl1+beta*Pis*p*[V0(1,Dhatid0(1,end));V0(2,Dhatid0(2,end))]);
          
    for i = 1:Ns 
        
        cs = s(i);                         
        
        for j = 1:Nmax 
            
            cD = Delta(j);
            
            if (j == 1) 
                
                 d1(i,j) = 0;
                 V1(i,j) = V_star(i);
                 k(i,j) = k_star(i);
                 b1(i,j) = 0;     
                 b1id(i,j) = 1;
                 Dplus1(i,j) = 0;
                 Dplusid1(i,j) = 1;    
                             
            else                
            
                d1mat = zeros(Nmax2,Nk);
                V1mat = d1mat;
                
                for m = 1:Nk 
                    
                    ck = Delta_k(i,m);
                    
                    for h = 1:Nmax2 
                        
                        cb = cD-1/(1+r)*Delta2(h);
                        
                        if (cb<0)
                            
                            d1mat(h,m) = -10000;
                            V1mat(h,m) = -10000;
                            
                        else
                            
                            d1mat(h,m) = cb+ beta*Pis(i,1)*((1-p)*d0(1,min(h,Nmax))+p*Dhat0(1,min(h,Nmax)));
                            d1mat(h,m) = d1mat(h,m) + beta*Pis(i,2)*((1-p)*d0(2,min(h,Nmax))+p*Dhat0(2,min(h,Nmax)));
                            
                            V1mat(h,m) = A*cs*ck^alpha-R*ck-cb+beta*Pis(i,1)*((1-p)*V0(1,min(h,Nmax))+p*V0(1,Dhatid0(1,min(h,Nmax))));
                            V1mat(h,m) = V1mat(h,m) + beta*Pis(i,2)*((1-p)*V0(2,min(h,Nmax))+p*V0(2,Dhatid0(2,min(h,Nmax))));
                                                        
                            if (V1mat(h,m)<G(i,m))
                                d1mat(h,m) = -10000;
                                V1mat(h,m) = -10000;
                            elseif (A*cs*ck^alpha-R*ck-cb<0)
                                d1mat(h,m) = -10000;
                                V1mat(h,m) = -10000;
                            end
                            
                        end
                        
                    end 
                    
                end
                                
                if (max(max(d1mat)) == -10000) 
                    
                    k(i,j) = k_npl1(i);
                    b1(i,j) = b_npl1(i);       
                    Dplusid1(i,j) = max(1,ceil((cD-b1(i,j))*(1+r)/delta)+1);
                    Dplus1(i,j) = Delta2(Dplusid1(i,j));
                    d1(i,j) = b1(i,j)+ beta*Pis(i,1)*((1-p)*d0(1,min(Dplusid1(i,j),Nmax))+p*Dhat0(1,min(Dplusid1(i,j),Nmax)));
                    d1(i,j) = d1(i,j) + beta*Pis(i,2)*((1-p)*d0(2,min(Dplusid1(i,j),Nmax))+p*Dhat0(2,min(Dplusid1(i,j),Nmax)));
                    V1(i,j) = A*cs*k(i,j)^alpha-R*k(i,j)-b1(i,j)+beta*Pis(i,1)*((1-p)*V0(1,min(Dplusid1(i,j),Nmax))+p*V0(1,Dhatid0(1,min(Dplusid1(i,j),Nmax))));
                    V1(i,j) = V1(i,j) + beta*Pis(i,2)*((1-p)*V0(2,min(Dplusid1(i,j),Nmax))+p*V0(2,Dhatid0(2,min(Dplusid1(i,j),Nmax))));                    
                                        
                else       

                    maxval = max(max(d1mat)); 
                    maxbidx = min(find(abs(max(d1mat,[],2)-maxval)<0.0000001));
                    b1(i,j) =  Delta_b(j,maxbidx);            
                    Dplusid1(i,j) = max(1,ceil((cD-b1(i,j))*(1+r)/delta)+1);                
                    Dplus1(i,j) = Delta2(Dplusid1(i,j));                    
                    maxkval  = max(V1mat(maxbidx,:));
                    maxkidx = max(find(abs(V1mat(maxbidx,:)-maxkval)<0.0000001));
                    k(i,j) = Delta_k(i,maxkidx);
                    V1(i,j) = V1mat(maxbidx,maxkidx);  
                    d1(i,j) = d1mat(maxbidx,maxkidx);
                   
                    if (Delta(j)>Dbar0(i))
                        if(d1(i,j)<d_npl1(i))
                             k(i,j) = k_npl1(i);
                             b1(i,j) = b_npl1(i);                      
                             Dplusid1(i,j) = max(1,ceil((cD-b1(i,j))*(1+r)/delta)+1);                
                             Dplus1(i,j) = Delta2(Dplusid1(i,j));                             
                             d1(i,j) = b1(i,j)+ beta*Pis(i,1)*((1-p)*d0(1,min(Dplusid1(i,j),Nmax))+p*Dhat0(1,min(Dplusid1(i,j),Nmax)));
                             d1(i,j) = d1(i,j) + beta*Pis(i,2)*((1-p)*d0(2,min(Dplusid1(i,j),Nmax))+p*Dhat0(2,min(Dplusid1(i,j),Nmax)));
                             V1(i,j) = A*cs*k(i,j)^alpha-R*k(i,j)-b1(i,j)+beta*Pis(i,1)*((1-p)*V0(1,min(Dplusid1(i,j),Nmax))+p*V0(1,Dhatid0(1,min(Dplusid1(i,j),Nmax))));
                             V1(i,j) = V1(i,j) + beta*Pis(i,2)*((1-p)*V0(2,min(Dplusid1(i,j),Nmax))+p*V0(2,Dhatid0(2,min(Dplusid1(i,j),Nmax))));                        
                                                                                
                        end
                    end
               
                end
                
            end
           
        end     
    end        
        
    distance1 = max(max((abs((V1 - V0)./V0))));
    distance2 = max(max((abs((d1 - d0)./d0))));
    display = sprintf ( ' iteration %4d    ||V1-V0|| = %8.6f  ||d1-d0|| = %8.6f ', iteration, max(max(abs(V1 - V0))), max(max(abs(d1 - d0))));
    disp(display)
    if (distance1 < precision && distance2 < precision)
        break
    end  
    
    iteration = iteration+1;    
    d0 = d1;
    V0 = V1; 
    Dbar1(1) = Delta(find(Dplus1(1,:)<Dbar0(1), 1, 'last' ));
    Dbar1(2) = Delta(max(find(Dplus1(2,:)<Dbar0(1))));
    Dbar0 = Dbar1;
    Dhat1 = zeros(Ns,Nmax);
    Dhatid1 = Dhat1;
    for i = 1:Ns
        for j = 1:Nmax
            [Dhat1(i,j), Dhatid1(i,j)] = max(d1(i,1:j));
        end
    end
    Dhat0 = Dhat1;
    Dhatid0 = Dhatid1;
    
    G_npl0 = B*k_npl1;
   
end

save d0 d0
save V0 V0

figure
subplot(2,2,1)
plot(Delta,d1(1,:),Delta,d1(2,:),'LineWidth',3);
title('d(s,D)', 'Fontname','Helvetica','FontSize', 20)
hold on
plot(Delta,Delta,'--','LineWidth',3)
xlim([Delta(1) Delta(end)])
set(gca, 'Fontname', 'Helvetica');
set(gca, 'Linewidth', 2);
set(gca, 'FontSize', 20);
hold off

subplot(2,2,2)
plot(Delta,b1(1,:),Delta,b1(2,:),'LineWidth',3)
title('b(s,D)', 'Fontname','Helvetica','FontSize', 20)
xlim([Delta(1) Delta(end)])
set(gca, 'Fontname', 'Helvetica');
set(gca, 'Linewidth', 2);
set(gca, 'FontSize', 20);

subplot(2,2,3)
plot(Delta,k(1,:),Delta,k(2,:),'LineWidth',3)
title('k(s,D)', 'Fontname','Helvetica','FontSize', 20)
xlim([Delta(1) Delta(end)])
set(gca, 'Fontname', 'Helvetica');
set(gca, 'Linewidth', 2);
set(gca, 'FontSize', 20);

subplot(2,2,4)
plot(Delta,V1(1,:),Delta,V1(2,:),'LineWidth',3)
title('V(s,D)', 'Fontname','Helvetica','FontSize', 20)
xlim([Delta(1) Delta(end)])
set(gca, 'Fontname', 'Helvetica');
set(gca, 'Linewidth', 2);
set(gca, 'FontSize', 20);